
(* for the bisimulation problem *)

structure B : SET =
struct

   (* rep. inv: in T(l, y, r), forall x in l, x < y, and forall x in r, x >= r *)
    datatype set = E | T of set * int * set

    val empty = E

    fun insert (a, E) = T(E, a, E)
      | insert (a, T(l, i, r)) =
        if a < i 
        then T(insert (a, l), i, r)
        else T(l, i, insert (a, r))

    fun member (E, _) = false
      | member (T(l, i, r), a) =
        if a < i 
        then member (l, a)
        else if a > i
             then member (r, a)
             else true

    fun smallest E = NONE
      | smallest (T(E, i, _)) = SOME i
      | smallest (T(l, _, _)) = smallest l

end