
(* a bi-directional Typechecker for PolyMinML. *)

structure Typing :> TYPING =
struct

    open Types
    open PolyMinML

    (* empty, ident, and ++ are defined in Types. You will want to
       use these for the contexts Delta and Gamma (and possibly
       other things, such as substitution) *)

    infix ++

    fun match (t1, t2) = 
        ignore (typeeq (t1, t2) orelse 
                raise TypeError ("failure in match:\n" ^ typetostring t1 ^ 
                                 " =/=\n" ^ typetostring t2 ^ "!"))

    (* check : (var -> unit) -> (var -> typ) -> cexp -> typ -> unit
     
       check D G c t

       checks that the expression c can have the type t in the type
       variable context D and the expression variable context G. If it
       cannot, then check raises the exception TypeError with an
       informative message.

       *)

    fun check D G (I i) t = ...






















































    (* infer : (var -> bool) -> (var -> typ) -> iexp -> typ
     
       infer D G i

       evaluates to the unique type of the expression i in
       the type variable context D and the expression variable
       context G. If this type does not exist, the function
       raises the exception TypeError with an informative message.

       *)

    and infer D G (Var x) = G x
      | infer D G (Int i) = INT
      | infer D G (Bool b) = ...
























































    (* the rest is complete for you, given working implementations of
       check and infer *)

    fun K x y = x

    (* exported typing function *)
    val typing = infer (K false) (empty "typing: unbound variable: ")

    fun typecheck e =
        let
            val t = typing e
        in
            print ("Type OK: " ^ typetostring t ^ "\n")
        end handle (ex as (TypeError s)) => 
            let in
                print ("Type Error: " ^ s ^ "\n" ^
                       "(" ^ exnMessage ex ^ ")\n");
                raise TypeError s
            end

end